SoEngine(3)

NAME
SoEngine - SoEngine is the base class for Coin engines.

SYNOPSIS

#include <Inventor/engines/SoEngine.h>

Inherits SoFieldContainer.

Inherited by SoBoolOperation, SoCalculator, SoComposeMatrix, SoComposeRotation, SoComposeRotationFromTo, SoComposeVec2f, SoComposeVec3f, SoComposeVec4f, SoComputeBoundingBox, SoConcatenate, SoCounter, SoDecomposeMatrix, SoDecomposeRotation, SoDecomposeVec2f, SoDecomposeVec3f, SoDecomposeVec4f, SoElapsedTime, SoFieldConverter, SoGate, SoInterpolate, SoOnOff, SoOneShot, SoProfilerTopEngine, SoSelectOne, SoTexture2Convert, SoTimeCounter, SoTransformVec3f, and SoTriggerAny.

  Public Member Functions
void evaluateWrapper (void)
virtual int getOutputs (SoEngineOutputList &l) const
SoEngineOutput * getOutput (const SbName &outputname) const
SbBool getOutputName (const SoEngineOutput *output, SbName &outputname) const
virtual const SoEngineOutputData * getOutputData (void) const =0
SbBool isNotifying (void) const
virtual void notify (SoNotList *nl)
SoEngine * copy (void) const
virtual SoFieldContainer * copyThroughConnection (void) const
SbBool shouldCopy (void) const
virtual void writeInstance (SoOutput *out)

  Static Public Member Functions
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.
static void initClasses (void)
static SoType getClassTypeId (void)
This static method returns the SoType object associated with objects of this class.
static SoEngine * getByName (const SbName &name)
static int getByName (const SbName &name, SoEngineList &el)

  Protected Member Functions
SoEngine (void)
virtual ~SoEngine (void)
virtual void evaluate (void)=0
virtual SbBool readInstance (SoInput *in, unsigned short flags)
virtual void inputChanged (SoField *which)
void writeOutputTypes (SoOutput *out)

  Static Protected Member Functions
static const SoFieldData ** getInputDataPtr (void)
static const SoEngineOutputData ** getOutputDataPtr (void)

  Additional Inherited Members

Detailed Description

SoEngine is the base class for Coin engines. Engines enable the application programmers to make complex connections between fields.

The most common cases where you use engines are: 1) to constrain the values of a field with regard to the contents of one or more other fields in the scene graph, 2) as a convenient way to animate parts of the scene graph.

The reference count of an engine will be increased by 1 for each connection made to one of its engine outputs, and decreased by one for a disconnect. See SoEngineOutput::addConnection() and SoEngineOutput::removeConnection(). When the reference count goes down to zero, the engine will automatically be destroyed, and subsequent attempts at using the engine will lead to a crash.

If you want complete control over when an engine gets destructed, use SoBase::ref() and SoBase::unref() for explicit referencing/dereferencing.

Constructor & Destructor Documentation

  SoEngine::SoEngine (void) [protected]
Default constructor.

  SoEngine::~SoEngine (void) [protected], [virtual]
Destructor.

Member Function Documentation

  void SoEngine::initClasses (void) [static]
Initializes all engines. Automatically called from SoEngine::initClass() upon initialization of Coin.

  void SoEngine::evaluateWrapper (void)
Triggers an engine evaluation.

  int SoEngine::getOutputs (SoEngineOutputList & l) const [virtual]
Adds all outputs to list. Returns the number of outputs added to the list.

  SoEngineOutput * SoEngine::getOutput (const SbName & outputname) const
Returns the output with name outputname, or NULL if no such output exists.

  SbBool SoEngine::getOutputName (const SoEngineOutput * output, SbName & outputname) const
Sets outputname to the name of output. Returns FALSE if no such output is contained within the engine instance.

  const SoEngineOutputData * SoEngine::getOutputData (void) const [pure virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implemented in SoProfilerTopEngine, SoBoolOperation, SoCalculator, SoComposeMatrix, SoComposeRotation, SoComposeRotationFromTo, SoComposeVec2f, SoComposeVec3f, SoComposeVec4f, SoComputeBoundingBox, SoConcatenate, SoCounter, SoDecomposeMatrix, SoDecomposeRotation, SoDecomposeVec2f, SoDecomposeVec3f, SoDecomposeVec4f, SoElapsedTime, SoFieldConverter, SoGate, SoHeightMapToNormalMap, SoInterpolate, SoInterpolateFloat, SoInterpolateRotation, SoInterpolateVec2f, SoInterpolateVec3f, SoInterpolateVec4f, SoOneShot, SoOnOff, SoSelectOne, SoTexture2Convert, SoTimeCounter, SoTransformVec3f, and SoTriggerAny.

  SoEngine * SoEngine::getByName (const SbName & name) [static]
Returns the engine named name, or NULL if no such engine exists. If several engines have been registered under the same name, returns the last one which was registered.

  int SoEngine::getByName (const SbName & name, SoEngineList & el) [static]
Finds all engines named name. Returns the number of engines added to the el list.

  SbBool SoEngine::isNotifying (void) const
Returns whether we're in a notification process. This is needed to avoid double notification when an engine enables outputs during inputChanged().

  void SoEngine::notify (SoNotList * l) [virtual]
Notifies all auditors for this instance when changes are made.

Reimplemented from SoFieldContainer.

  SoEngine * SoEngine::copy (void) const
Make a duplicate of this engine and return a pointer to the duplicate.

Connections are shallow copied, i.e. the node or engine instance at the other end of the connection is not cloned. We just let the connection reference from the cloned engine refer to the same instance as the engine we've cloned ourselves from.

Note that this is not the function the application programmer should override if she needs some special behavior during a copy operation (like copying the value of internal data not exposed as fields). For that purpose, override the copyContents() method. Your overridden copyContents() method should then both copy internal data as well as calling the parent superclass' copyContents() method for automatically handling of fields and other common data.

  SoFieldContainer * SoEngine::copyThroughConnection (void) const [virtual]
Return copy of this instance.

Note: default implementation just returns this pointer, SoNode and SoEngine overrides this method to return the pointer to the actual copy.

Reimplemented from SoFieldContainer.

  SbBool SoEngine::shouldCopy (void) const
Returns whether this engine should be copied or simply referenced in a copy operation.

Engines which are not really part of the scene graph should not be copied.

  void SoEngine::writeInstance (SoOutput * out) [virtual]
Writes all the fields contained in this instance to the output stream within out.

This method is solely called from the write methods of fields.

Either from SoField if the write is done because of a field-to-field connection, or from one of the fields which may actually write SoFieldContainer instances, i.e. SoSFNode, SoMFNode, SoSFEngine, SoMFEngine, SoSFPath and SoMFPath.

This method, in addition to the ordinary write() method of SoNode, needs to be present since the fields don't have a write action instance in their writeValue() method, and writeInstance() will create a new SoWriteAction and call continueToApply() on it.

Reimplemented from SoFieldContainer.

Reimplemented in SoElapsedTime, and SoTimeCounter.

  void SoEngine::evaluate (void) [protected], [pure virtual]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.

Implemented in SoProfilerTopEngine, and SoHeightMapToNormalMap.

  SbBool SoEngine::readInstance (SoInput * in, unsigned short flags) [protected], [virtual]
This method is mainly intended for internal use during file import operations.

It reads a definition of an instance from the input stream in. The input stream state points to the start of a serialized / persistent representation of an instance of this class type.

TRUE or FALSE is returned, depending on if the instantiation and configuration of the new object of this class type went OK or not. The import process should be robust and handle corrupted input streams by returning FALSE.

flags is used internally during binary import when reading user extension nodes, group nodes or engines.

Reimplemented from SoFieldContainer.

  void SoEngine::inputChanged (SoField * which) [protected], [virtual]
Called when an input is changed. The default method does nothing, but subclasses may override this method to do The Right Thing when a specific field is changed.

Reimplemented in SoCalculator, SoGate, SoHeightMapToNormalMap, and SoTimeCounter.

  const SoFieldData ** SoEngine::getInputDataPtr (void) [static], [protected]
Returns the SoFieldData class which holds information about inputs in this engine.

  const SoEngineOutputData ** SoEngine::getOutputDataPtr (void) [static], [protected]
Returns the SoEngineOutputData class which holds information about the outputs in this engine.

  void SoEngine::writeOutputTypes (SoOutput * out) [protected]
Writes the types of engine outputs for extension engines (i.e. engines not built in to Coin).

Author

Generated automatically by Doxygen for Coin from the source code.